<template>
  <div class="p-2">
    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="22">
            <span>支付设置信息列表</span>
          </el-col>
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['system:paySet:add']">新增</el-button>
          </el-col>
        </el-row>
      </template>
      <el-table v-loading="loading" border :data="paySetList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="编号" align="center" prop="payCode" />
        <el-table-column label="支付方式名称" align="center" prop="payName" />
        <el-table-column label="描述" align="center" prop="payDescription" />
        <el-table-column label="环境" align="center" prop="payEnvironment" />
        <el-table-column label="是否显示" align="center" prop="isShow">
          <template #default="scope">
            <el-switch v-model="scope.row.status" active-value="0" inactive-value="1" @change="handleStatusChange(scope.row)"></el-switch>
          </template>
        </el-table-column>
        <el-table-column label="数据来源" align="center" prop="dataSource" />
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['system:paySet:edit']">编辑</el-button>
          </template>
        </el-table-column>
      </el-table>
      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改支付方式类型对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="paySetFormRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="支付方式" prop="payName">
          <el-input v-model="form.payName" placeholder="请输入支付方式名称" />
        </el-form-item>
        <el-form-item label="支付环境" prop="payEnvironment">
          <el-input v-model="form.payEnvironment" placeholder="请输入支付环境" />
        </el-form-item>
        <el-form-item label="是否显示" prop="isShow">
          <el-radio-group v-model="form.isShow">
            <el-radio v-for="dict in sys_platform_yes_no" :key="dict.value" :value="dict.value">{{ dict.label }}</el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item label="描述" prop="payDescription">
          <el-input v-model="form.payDescription" type="textarea" placeholder="请输入内容" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="PaySet" lang="ts">
import { listPaySet, getPaySet, delPaySet, addPaySet, updatePaySet, changeStatus } from '@/api/order/paySet';
import { PaySetVO, PaySetQuery, PaySetForm } from '@/api/order/paySet/types';

const { proxy } = getCurrentInstance() as ComponentInternalInstance;
const { sys_platform_yes_no } = toRefs<any>(proxy?.useDict('sys_platform_yes_no'));

const paySetList = ref<PaySetVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);

const queryFormRef = ref<ElFormInstance>();
const paySetFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: PaySetForm = {
  id: undefined,
  payCode: undefined,
  payName: undefined,
  payDescription: undefined,
  payEnvironment: undefined,
  isShow: '0',
  dataSource: undefined,
  status: undefined,
  remark: undefined
};
const data = reactive<PageData<PaySetForm, PaySetQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    payCode: undefined,
    payName: undefined,
    payDescription: undefined,
    payEnvironment: undefined,
    isShow: undefined,
    dataSource: undefined,
    status: undefined,
    platformCode: undefined,
    params: {}
  },
  rules: {
    payName: [{ required: true, message: '支付方式名称不能为空', trigger: 'blur' }],
    isShow: [{ required: true, message: '是否显示不能为空', trigger: 'change' }]
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询支付方式类型列表 */
const getList = async () => {
  loading.value = true;
  const res = await listPaySet(queryParams.value);
  paySetList.value = res.rows;
  total.value = res.total;
  loading.value = false;
};

const handleStatusChange = async (row: PaySetVO) => {
  const oldValue = row.isShow; // 保存旧值（0 或 1）

  try {
    await changeStatus(row.id, row.isShow); // 传新值
    proxy?.$modal.msgSuccess('操作成功');
  } catch {
    row.isShow = oldValue; // 失败回滚
    proxy?.$modal.msgError('操作失败，请重试');
  }
};

/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
};

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  paySetFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
};

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};

/** 多选框选中数据 */
const handleSelectionChange = (selection: PaySetVO[]) => {
  ids.value = selection.map((item) => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
};

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = '添加支付方式类型';
};

/** 修改按钮操作 */
const handleUpdate = async (row?: PaySetVO) => {
  reset();
  const _id = row?.id || ids.value[0];
  const res = await getPaySet(_id);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = '修改支付方式类型';
};

/** 提交按钮 */
const submitForm = () => {
  paySetFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.id) {
        await updatePaySet(form.value).finally(() => (buttonLoading.value = false));
      } else {
        await addPaySet(form.value).finally(() => (buttonLoading.value = false));
      }
      proxy?.$modal.msgSuccess('操作成功');
      dialog.visible = false;
      await getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row?: PaySetVO) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm('是否确认删除支付方式类型编号为"' + _ids + '"的数据项？').finally(() => (loading.value = false));
  await delPaySet(_ids);
  proxy?.$modal.msgSuccess('删除成功');
  await getList();
};

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download(
    'system/paySet/export',
    {
      ...queryParams.value
    },
    `paySet_${new Date().getTime()}.xlsx`
  );
};

onMounted(() => {
  getList();
});
</script>
